#property copyright "hexadecimal"
#property link      "BcB Group"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red

int G_timeframe_76 = PERIOD_M15;
int Gi_80 = 10;
int Gi_84 = 13;
int Gi_88 = 8;
extern bool ShowSettingsOnChart = FALSE;
double G_ibuf_96[];
double G_ibuf_100[];
int Gia_104[];

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 163);
   SetIndexBuffer(0, G_ibuf_96);
   SetIndexStyle(1, DRAW_ARROW, EMPTY, 0);
   SetIndexArrow(1, 163);
   SetIndexBuffer(1, G_ibuf_100);
   SetIndexEmptyValue(0, 0.0);
   IndicatorShortName("ZigZagPhat (" + G_timeframe_76 + ")");
   if (ShowSettingsOnChart == TRUE) {
      Comment("\nZigZag Forced Time (" + G_timeframe_76 + ")\nZigZag Exit Depth (" + Gi_80 + ")\nZigZag Exit Deviation (" + Gi_84 + ")\nZigZag Exit Backstep (" + Gi_88 +
         ")");
   }
   ArrayCopySeries(Gia_104, 5, Symbol(), G_timeframe_76);
   return (0);
}
		  	 	   	  			 			  		  		 	   	  	 				    							 		    						   		  	 							 		   				 			  		   		 	 							   		 	 	 					   		 	   			 	
// 52D46093050F38C27267BCE42543EF60
int deinit() {
   return (0);
}
	 			 	  	 	 			      		 	   	    			 			 		  			   	 		 								 		 		   	 					 	 	   	    			 	     			 						  	  		  	  				 		 		 							 	
// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   int count_0;
   double icustom_16;
   double icustom_24;
   int Li_4 = IndicatorCounted();
   if (Li_4 < 0) return (-1);
   if (Li_4 > 0) Li_4--;
   int Li_8 = Bars - Li_4;
   for (int index_12 = 0; index_12 < Li_8; index_12++) {
      if (Time[index_12] >= Gia_104[0]) count_0 = 0;
      else {
         count_0 = ArrayBsearch(Gia_104, Time[index_12 - 1], WHOLE_ARRAY, 0, MODE_DESCEND);
         if (Period() <= G_timeframe_76) count_0++;
      }
      icustom_16 = iCustom(NULL, G_timeframe_76, "ZigZag", Gi_80, Gi_84, Gi_88, 0, count_0);
      icustom_24 = iCustom(NULL, G_timeframe_76, "ZigZag", Gi_80, Gi_84, Gi_88, 1, count_0);
      if (icustom_24 > 0.0 && icustom_24 >= High[index_12]) {
         f0_1(index_12, High[index_12]);
         G_ibuf_96[index_12] = icustom_24;
      } else f0_1(index_12, 0);
      if (icustom_16 > 0.0 && icustom_16 <= Low[index_12]) {
         f0_0(index_12, Low[index_12]);
         G_ibuf_100[index_12] = icustom_16;
      } else f0_0(index_12, 0);
   }
   return (0);
}
		 		 	   		 			 		   		  	  	   	 		 				 	  					 	 		   							 	 		  	  						  	   			  			  	    		 										  		 	   					 	 		 	  				 	
// 46C48BEC0D282018B9D167EEF7711B2C
void f0_0(int Ai_0, double A_price_4) {
   double iatr_12 = iATR(NULL, 0, 10, Ai_0);
   string name_20 = "up_" + Time[Ai_0];
   if (A_price_4 == 0.0) {
      ObjectDelete(name_20);
      return;
   }
   ObjectCreate(name_20, OBJ_ARROW, 0, Time[Ai_0], A_price_4);
   ObjectSet(name_20, OBJPROP_ARROWCODE, 158);
   ObjectSet(name_20, OBJPROP_COLOR, Aqua);
   ObjectMove(name_20, 0, Time[Ai_0], A_price_4);
}
	   	  	 		  	    		     			 			    	   	       	 			    	  		  	    	 	   			  	  		 			 		 	   			  	 			 		  	 	        	 	  	    	 			  		 		
// D4579B2688D675235F402F6B4B43BCBF
void f0_1(int Ai_0, double A_price_4) {
   double iatr_12 = iATR(NULL, 0, 10, Ai_0);
   string name_20 = "do_" + Time[Ai_0];
   if (A_price_4 == 0.0) {
      ObjectDelete(name_20);
      return;
   }
   ObjectCreate(name_20, OBJ_ARROW, 0, Time[Ai_0], A_price_4);
   ObjectSet(name_20, OBJPROP_ARROWCODE, 158);
   ObjectSet(name_20, OBJPROP_COLOR, Red);
   ObjectMove(name_20, 0, Time[Ai_0], A_price_4);
}
